#include <stdio.h>
#include <stdlib.h>

#include "trie_sedgewick.h"

int main(int argc, char ** argv)
   {
   struct trie * trie = trie_new();
   if (NULL == trie)
      {
      fprintf(stderr, "trie_new failed\n");
      exit(EXIT_FAILURE);
      }

   char * words[] = 
	 {
	 "she", "sells", "sea", "shells", "by", "the", "sea", "shore", NULL,
	 };

   printf("Loading trie\n");
   char ** w = words;
   while (*w)
      {
      if (NULL == trie_put(trie, *w, *w))
	 {
	 fprintf(stderr, "trie_put failed on %s\n", *w);
	 exit(EXIT_FAILURE);
	 }
      w++;
      }

   printf("Reading trie\n");
   w = words;
   while (*w)
      {
      char * value;
      if (NULL == (value = trie_get(trie, *w)))
	 {
	 fprintf(stderr, "trie_get failed on %s\n", *w);
	 exit(EXIT_FAILURE);
	 }
      printf("%s\n", value);
      w++;
      }

   exit(EXIT_SUCCESS);
   }
